/*
 ķ
   Program..: _DCACHOI.PRG                                     
   Author...: Roger J. Donnay                                  
   Notice...: (c) DONNAY Software Designs 1987-2001            
   Date.....: Mar 27, 2001                                     
   Notes....: Moused replacement for ACHOICE()                 
   Functions:  dc_achoice(), dc_readapick(), dc_guiachoice()   
 Ľ
*/


/*
------------------------------------------------------------------------------
28-04-2025 www.cobasystems.com, COBA Systems

Using the eXpress functions:
DC_Achoice() and DC_GuiAchoice() under Windows 11
is possible with the following modification:

The function dc_guiachoice() was extracted from prg:
  C:\exp20\Source\Dclipx\_dcachoi.prg
in DC_GUIACHOICE1.PRG
and modified by adding:
  nTop    *= 20
  nBottom *= 20
  nLeft   *= 10
  nRight  *= 10
The line causing the error has been disconnected:
  nElement := AScan( aMenuItems, {|a|Upper(Left(a[1],1))==cChar}, nElement+1 )
and a line was added:
  nElement :=  Ascan( aMenuItems, cChar, nElement+1)

All these changes were made only in DC_GUIACHOICE1.PRG.
After these changes, DC_GUIACHOICE1.PRG is linked into the application.
Now the function DC_GuiAchoice() can be called directly from the application
and it will work without any problems.
The entire example is given in the file DC_GUIACHOICE.ZIP
------------------------------------------------------------------------------
*/



#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "xbtsys.ch"


#include "SET.CH"
#include "INKEY.CH"
#include "DCDIALOG.CH"
#include "DCCOLOR.CH"



FUNCTION dc_guiachoice ( nTop, nLeft, nBottom, nRight, aMenuItems, ;
                         aSelectItems, cUserFunction, nElement,;
                         nWinStart, cTitle, aHelpCodes, aMenu,;
                         cFontName, oDlg, lDestroy, aMessage, cHeader, ;
                         lCenter, lModal )

LOCAL nEvent, oXbp, mp1, mp2, aArray, i, nWidth, nHeight, oParent, oOwner, ;
      oAppFocus := SetAppFocus(), lWinStart, oAppWindow := SetAppWindow(), ;
      cChar

*******************  "added by Coba start
  nTop    *= 20
  nBottom *= 20
  nLeft   *= 10
  nRight  *= 10
*******************  "added by Coba end


DEFAULT cFontName := '8.Courier', ;
        lDestroy  := .t., ;
        lCenter   := .f., ;
        nWinStart := 1, ;
        lModal    := .f.



aArray := { aMenuItems, 1 }

IF Valtype(oDlg)#'O'

  oParent := AppDeskTop()
  oOwner  := SetAppWindow()
  nWidth  := nRight - nLeft
  nHeight := nBottom - nTop
  nTop := oParent:currentSize()[2]-nHeight-nTop

 ****************************************************************************
  oDlg := XbpDialog():new( oParent, oOwner, ;
                      { nLeft, nTop },;
                      { nWidth+40, nHeight+40 },,; // +40 added by Coba
                       .F. )
 *****************************************************************************

  * nLeft - distance from the left side of the monitor
  * nTop  - distance from the bottom row of monitors


  IF Valtype(DC_IconDefault())$'NO'
    oDlg:icon := DC_IconDefault()
  ENDIF

  oDlg:sysmenu   := .t.
  oDlg:taskList  := .t.
  oDlg:minbutton := .f.
  oDlg:maxbutton := .f.
  oDlg:title     := cTitle

  oDlg:drawingArea:setFontCompoundName( cFontName )
  oDlg:create()

  IF lModal
    oDlg:SetModalState(XBP_DISP_APPMODAL)
  ENDIF

  IF lCenter
    DC_CenterObject(oDlg,SetAppWindow())
  ENDIF

  SetAppWindow(oDlg)

  IF Valtype(aMenu) = 'A'
    // Install menu on Dialog window
    DC_MenuOSys( aMenu, oDlg, .f. )
  ENDIF

  IF Valtype(aMessage)='A'
    FOR i := 1 TO LEN(aMessage)
      oXbp := XbpStatic():new( oDlg:drawingArea, , ;
              { 20,nHeight-(i*17)-34 },{nWidth-7,15} )
      oXbp:caption := aMessage[i]
      oXbp:autosize := .t.
      oXbp:create()
    NEXT
    nTop += LEN(aMessage)*17 + 25
  ENDIF

  // The browse is resized to fill the entire window
  oDlg:drawingArea:resize := ;
      {|mp1,mp2,obj| obj:childList()[1]:setSize(mp2) }

  ***************************************************************
  oDlg:cargo := ;
    XbpBrowse():new( oDlg:drawingArea,,{20,20},; // {20,20} added by Coba
                      {nWidth-7, nHeight-30},;
                      DC_GuiBrowParam() ):create()
  ***************************************************************

  oDlg:cargo:setFontCompoundName( cFontName )
  oDlg:cargo:cargo         := aArray
  oDlg:cargo:skipBlock     := {|n,obj| SkipArray( n, obj:cargo ) }
  oDlg:cargo:goTopBlock    := {|obj| obj:cargo[2] := 1 }
  oDlg:cargo:goBottomBlock := {|obj| obj:cargo[2] := Len( obj:cargo[ 1 ] ) }
  oDlg:cargo:posBlock      := {|obj| obj:cargo[2] }
  oDlg:cargo:phyPosBlock   := {|obj| obj:cargo[2] }
  oDlg:cargo:lastPosBlock  := {|obj| Len( obj:cargo[1] ) }
  oDlg:cargo:firstPosBlock := {|obj| 1  }

  oDlg:cargo:softTrack := .f.
  oDlg:cargo:addColumn( {||aArray[1,aArray[2]]}, (nRight-nLeft)/7, cHeader )

  IF lWinStart := ( Valtype(nWinStart) = 'N' .AND. nWinStart > 0 .AND. ;
                    nWinStart <= Len(aMenuItems) )

    oDlg:cargo:cargo[2] := nWinStart
    oDlg:cargo:show()
    oDlg:cargo:refreshAll()

  ENDIF

  IF Valtype(nElement) = 'N' .AND. nElement > 0 .AND. nElement <= Len(aMenuItems)
    IF lWinStart
      FOR i := 1 TO nElement - nWinStart
        oDlg:cargo:down()
      NEXT
    ELSE
      oDlg:cargo:cargo[2] := nElement
      oDlg:cargo:show()
      oDlg:cargo:refreshAll()
    ENDIF
  ENDIF

  // Display window
  oDlg:show()

  // Display browser.
  oDlg:cargo:show()
  oDlg:cargo:refreshAll()

  oBrowse := oDlg:cargo  // added by Coba // PUBLIC oBrowse DC_ACHOICE_MENU.PRG

ELSE

  oDlg:cargo:refreshcurrent()

  oBrowse := oDlg:cargo  // added by Coba // PUBLIC oBrowse DC_ACHOICE_MENU.PRG

ENDIF

// Set focus to browser
SetAppFocus( oDlg )
SetAppFocus( oDlg:cargo:GetColumn(1) )


nElement := 0

// Event loop
DO WHILE nEvent <> xbeP_Close

  nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
  IF Valtype(oXbp) = 'O'
    oXbp:handleEvent( nEvent, mp1, mp2 )
  ENDIF
  nElement := oDlg:cargo:cargo[2]

  IF nEvent = xbeP_Keyboard .AND. (oXbp==oDlg:cargo .OR. oXbp==oDlg .OR. oXbp==oDlg:cargo:GetColumn(1))

    IF mp1 = K_ENTER
      DC_ClearEvents()
      EXIT
    ELSEIF mp1 = K_ESC
      nElement := 0
      EXIT
    ENDIF

    cChar := Upper(Chr(mp1))

//    IF Valtype(aMenuItems) = 'A'
//      ****************************************************************************
//      nElement := AScan( aMenuItems, {|a|Upper(Left(a[1],1))==cChar}, nElement+1 )  // turned off by Coba
//      ****************************************************************************
//    ENDIF


    nElement :=  Ascan( aMenuItems, cChar, nElement+1) // added by Coba


    IF nElement > 0
      oDlg:cargo:cargo[2] := nElement
      oDlg:cargo:refreshAll()
    ENDIF

  ELSEIF nEvent = xbeBRW_ItemSelected .AND. oXbp==oDlg:cargo
    EXIT
  ENDIF

ENDDO

IF nEvent == xbeP_Close
  nElement := 0
ENDIF

SetAppWindow(oAppWindow)

IF lDestroy
  IF lModal
    oDlg:SetModalState(XBP_DISP_MODELESS)
  ENDIF
  oDlg:Destroy()
ENDIF

SetAppFocus(oAppFocus)

RETURN nElement

/* ------------------------ */

STATIC FUNCTION SkipArray( nWantSkip, aArray )

LOCAL nDidSkip, nLastRec := Len( aArray[1] )

   IF aArray[2] + nWantSkip < 1              // "BoF"
      nDidSkip := 1 - aArray[2]
   ELSEIF aArray[2] + nWantSkip > nLastRec   // "EoF"
      nDidSkip := nLastRec - aArray[2]
   ELSE
      nDidSkip := nWantSkip
   ENDIF
   aArray[2] += nDidSkip

RETURN nDidSkip

* -------------------- *
